/*
Copyright 2006-2007, U.S. Robotics Corporation
All Rights Reserved.

THIS SOFTWARE IS OFFERED "AS IS", AND U.S. Robotics GRANTS NO WARRANTIES OF ANY
KIND, EXPRESS OR IMPLIED, BY STATUTE, COMMUNICATION OR OTHERWISE. U.S. Robotics
SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
FOR A SPECIFIC PURPOSE OR NONINFRINGEMENT CONCERNING THIS SOFTWARE.
*/
var bDirty = false;
function WeekdayName(ix)
{	switch (ix)
	{	case 0:	return "Sunday";	break;
		case 1:	return "Monday";	break;
		case 2:	return "Tuesday";	break;
		case 3:	return "Wednesday";	break;
		case 4:	return "Thursday";	break;
		case 5:	return "Friday";	break;
		case 6:	return "Saturday";	break;
		default: return "<unknown>";	break;
	}
}
function manageWANoptions()
{      		var radios = document.idForm.optModem;
		setVisibility('idCablePrompts', radios[0].checked);
		setVisibility('idADSLprompts', radios[1].checked);
		if (document.idForm.chkHaveStaticIP != null)
			setVisibility('idStaticIPfields', document.idForm.chkHaveStaticIP.checked);
}
function check_firewall()
{	if (!document.idForm.chkFirewall.checked)
		document.idForm.fw_disable.value="1";
}
function setup_wanproto(s)
{	var radios = document.idForm.optModem;
	if (s == 1)
	{	var value = document.idForm.wan_pppoe_idletime.value;
		document.idForm.wan_pppoe_idletime.value = value * 60;
	}
	if (radios[0].checked) {
		document.idForm.wan_proto.value = "dhcp";
		if (document.idForm.chkHaveStaticIP.checked)
			document.idForm.wan_proto.value = "static";
		else {
			document.idForm.wan_ipaddr.value = "0.0.0.0";
			document.idForm.wan_netmask.value = "0.0.0.0";
			document.idForm.wan_gateway.value = "0.0.0.0";
			document.idForm.wan_dns.value = "";
			document.idForm.wan_wins.value = "";
		}
	}
	if (radios[1].checked) {
		document.idForm.wan_proto.value = "pppoe";
		document.idForm.wan_ipaddr.value = "0.0.0.0";
		document.idForm.wan_netmask.value = "0.0.0.0";
		document.idForm.wan_gateway.value = "0.0.0.0";
		document.idForm.wan_dns.value = "";
		document.idForm.wan_wins.value = "";
		if (document.idForm.chkCxn != null) {
			if (document.idForm.chkCxn.checked)
				document.idForm.connection.value = "demand";
		}
	}
	if (document.idForm.chkUsePPTP != null)
	{	if (document.idForm.chkUsePPTP.checked)
			document.idForm.wan_pptp_activated.value = "1";
		if (document.idForm.chkRemoteAccess != null) {
			if (!document.idForm.chkRemoteAccess.checked)
			document.idForm.http_wanport.value = "";
		}
	}
}
function verifyDeparture()
{
	if (bDirty)
		event.returnValue = "You have made changes to this page. If you leave the page without saving them, your changes will be lost.";
}
function reloadDevice()
{
	return confirm("If you want to restore the device to the original factory settings, press OK. Press Cancel to do nothing.");
}

function validateKeyForType(key, idType)
{	var eltType = document.getElementById(idType);
	if ((eltType == null) || !eltType.style || (eltType.style.display == null))
		return;
	var bits = 64;
	if ((eltType.selectedIndex == 0) || (eltType.selectedIndex == 1))
		bits = 128;
	var bHex = true;
	if ((eltType.selectedIndex == 0) || (eltType.selectedIndex == 2))
		bHex = false;
	if (key.length != getKeyLength(bits, bHex)) {
		return alert("The length of the key is incorrect. A 128-bit key must be 13 characters long in ASCII or 26 characters long in hexadecimal. A 64-bit key must be 5 characters long in ASCII or 10 characters long in hexadecimal."); 
		return false;
	}
	if (bHex) {
		if (!isHex(key)) {
			return alert("The key contains non-hexadecimal characters. A hexadecimal character is part of the following character set: 0-9, a-f or A-F."); 
			return false;
		}
	}
	return true;
}
function copySSIDandMAC()
{	document.idForm.txtMACaddress.value = document.idForm.cbSurvey.options[document.idForm.cbSurvey.selectedIndex].value;
}
function is8021xselected(ix)
{	return ((ix >= 5) && (ix <= 7));
}
function isWPAselected(ix, change)
{	if (change == 0) {     //security.asp
		return ((ix >= 0) && (ix <= 2));
	}
	else {  //setup_sec.asp
		return ((ix == 0));
	}
}
function isWEPselected(ix, change)
{	if (change == 0) {     //security.asp
		return ((ix >= 3) && (ix <= 4));
	}
	else {  //setup_sec.asp
		return ((ix >= 1) && (ix <= 2));
	}
}
function isWPA2selected(ix, change)
{	if (change == 0)  {   //security.asp
		return (((ix >= 0) && (ix <= 1)) || ((ix >= 5) && (ix <= 6)));
	}
	else {   //setup_sec.asp
		return ((ix == 0));
	}
}
function setMaxLength(bClearValues, change)
{	var ixSecurity = document.idForm.cbAuthEncrypt.selectedIndex;
	if (isWEPselected(ixSecurity, change))
	{	var bHex = (document.idForm.cbWEPkeytype[1].selected || document.idForm.cbWEPkeytype[3].selected);
		var iBits = 128;
		if (document.idForm.cbWEPkeytype[2].selected || document.idForm.cbWEPkeytype[3].selected)
			iBits = 64;
		var iMaxLength = getKeyLength(iBits, bHex);
		document.getElementById("idKeyNumChars").innerHTML = iMaxLength;
		document.idForm.wl_key1.maxLength = iMaxLength;
		if (document.idForm.wl_key2 != null)
		{	document.idForm.wl_key2.maxLength = iMaxLength;
			document.idForm.wl_key3.maxLength = iMaxLength;
			document.idForm.wl_key4.maxLength = iMaxLength;
		}
		if (bClearValues)
		{	document.idForm.wl_key1.value = "";
			if (document.idForm.wl_key2 != null)
			{	document.idForm.wl_key2.value = "";
				document.idForm.wl_key3.value = "";
				document.idForm.wl_key4.value = "";
			}
		}
	}
}
function onSecurityChange(bClearValues, change)
{	var ixSecurity = document.idForm.cbAuthEncrypt.selectedIndex;
	var bWEP = isWEPselected(ixSecurity, change);
	setVisibility('idWEPkeytype',	bWEP);
	setVisibility('idKey1',		bWEP);
	if (change == 0)
	{	setVisibility('idKey2',		bWEP);
		setVisibility('idKey3',		bWEP);
		setVisibility('idKey4',		bWEP);
		setVisibility('idKeyCurrent',	bWEP);
	}
	var bWPA = isWPAselected(ixSecurity, change);
	setVisibility('idPassPhrase',	bWPA);
	if (change == 0)
	{	setVisibility('idKeyRotation',	bWPA);
		var b8021x = is8021xselected(ixSecurity);
		setVisibility('idRADIUSserver',	b8021x);
		setVisibility('idRADIUSport',	b8021x);
		setVisibility('idRADIUSkey',	b8021x);
		setVisibility('idRADIUSReauth',	b8021x);
		setVisibility('idRADIUSPreauth',b8021x && isWPA2selected(ixSecurity, change));
		setVisibility('idEncryption',	bWPA || b8021x);
	}
	setMaxLength(bClearValues, change);
}
function manageSupportedRates()
{  if (document.idForm.cbMode.selectedIndex == 2)
   {	document.idForm.cbSupportedRate.options.length = 7;
	document.idForm.cbMRate.options.length = 7;
   }
   else
   {  if (document.idForm.cbSupportedRate.options.length < 13)
      {  document.idForm.cbSupportedRate.options[document.idForm.cbSupportedRate.options.length] = new Option("12 Mbps", "rate12");
         document.idForm.cbSupportedRate.options[document.idForm.cbSupportedRate.options.length] = new Option("18 Mbps", "rate18");
         document.idForm.cbSupportedRate.options[document.idForm.cbSupportedRate.options.length] = new Option("24 Mbps", "rate24");
         document.idForm.cbSupportedRate.options[document.idForm.cbSupportedRate.options.length] = new Option("36 Mbps", "rate36");
         document.idForm.cbSupportedRate.options[document.idForm.cbSupportedRate.options.length] = new Option("48 Mbps", "rate48");
         document.idForm.cbSupportedRate.options[document.idForm.cbSupportedRate.options.length] = new Option("54 Mbps", "rate54");
      }
      if (document.idForm.cbMRate.options.length < 13)
      {  document.idForm.cbMRate.options[document.idForm.cbMRate.options.length] = new Option("12 Mbps", "rate12");
         document.idForm.cbMRate.options[document.idForm.cbMRate.options.length] = new Option("18 Mbps", "rate18");
         document.idForm.cbMRate.options[document.idForm.cbMRate.options.length] = new Option("24 Mbps", "rate24");
         document.idForm.cbMRate.options[document.idForm.cbMRate.options.length] = new Option("36 Mbps", "rate36");
         document.idForm.cbMRate.options[document.idForm.cbMRate.options.length] = new Option("48 Mbps", "rate48");
         document.idForm.cbMRate.options[document.idForm.cbMRate.options.length] = new Option("54 Mbps", "rate54");
      }
   }
}
function checksettings()
{	if (!document.idForm.chkWireless.checked)
		document.idForm.wl_radio.value="0";
	if (document.idForm.wlmode.checked)
		document.idForm.wl_mode.value="wds";
        if (!document.idForm.chkWDSrestrict.checked) 
		document.idForm.wl_lazywds.value="1";
	if (document.idForm.chkWME != null) {
		if (document.idForm.chkWME.checked) 
			document.idForm.wl_wme.value="on";
	} 
}
function checkDHCP()
{	if (!document.idForm.chkDHCP.checked)
		document.idForm.lan_proto.value="static";	
}
function new_lease(s)
{	var day = document.idForm.txtLeaseDays.value;
	var hour = document.idForm.txtLeaseHours.value;
	var minutes = document.idForm.txtLeaseMinutes.value;
	var lan_lease = day*86400 + hour*3600 + minutes*60;
	if ((lan_lease == 0) || (lan_lease > 604800)) {
		alert("Please enter a lease time greater than zero and less than seven days.");
		if (s)
			return false;
	}else {
		document.idForm.lan_lease.value = lan_lease;
		return true;
	}
}
function new_reauth()
{	var minutes = document.idForm.wl_net_reauth.value;
	var seconds = minutes*60;
	document.idForm.wl_net_reauth.value = seconds;
}
function inet_aton(a)
{	var n;
	n = a.split(/\./);
	if (n.length != 4)
		return 0;
	return ((n[0] << 24) | (n[1] << 16) | (n[2] << 8) | n[3]);
}
function inet_ntoa(n)
{	var a;
	a = (n >> 24) & 255;
	a += "."
	a += (n >> 16) & 255;
	a += "."
	a += (n >> 8) & 255;
	a += "."
	a += n & 255;
	return a;
}
function lan_ipaddr_change()
{	var lan_netaddr, lan_netmask, dhcp_start, dhcp_end;
	lan_netaddr = inet_aton(document.idForm.lan_ipaddr.value);
	lan_netmask = inet_aton(document.idForm.lan_netmask.value);
	lan_netaddr &= lan_netmask;
	dhcp_start = inet_aton(document.idForm.dhcp_start.value);
	dhcp_start &= ~lan_netmask;
	dhcp_start |= lan_netaddr;
	dhcp_end = inet_aton(document.idForm.dhcp_end.value);
	dhcp_end &= ~lan_netmask;
	dhcp_end |= lan_netaddr;
	document.idForm.dhcp_start.value = inet_ntoa(dhcp_start);
	document.idForm.dhcp_end.value = inet_ntoa(dhcp_end);
}

function tableDeleteRowDDNS(objTable, ixRow, strIDnotice)
{	tableDeleteRow(objTable, ixRow);
	setVisibility(strIDnotice, true);
}
var reService = "(.*?)";
var reHost = "(.*?)";
var reUser = "(.*?)";
var rePass = "(.*?)";
var reActive = "(.*?)";
var reStat = "(.*?)";
var reLink = "(.*?)";

function fctFormatRowDDNS(objTable, row)
{	var aRow = objTable.aRows[row];
	var strHTML = "<tr valign=\"top\">";
	strHTML += "<td><input type=\"checkbox\"" + (aRow[0] == "on" ? " checked" : "") + " onclick=\"tableModifyValue(" + objTable.strThis + ", " + row + ", 0);\">";
	strHTML += "<input type=\"hidden\" name=\"" + objTable.aVarNamePrefixes[0] + row + "\" value=\"" + aRow[0] + "\">";
	strHTML += "<\/td>";
	strHTML += "<td class=\"clsEntry\">";
	strHTML += aRow[1];
	strHTML += "<input type=\"hidden\" name=\"" + objTable.aVarNamePrefixes[1] + row + "\" value=\"" + aRow[1] + "\">";
	strHTML += "<\/td>";
	strHTML += "<td class=\"clsEntry\">";
	strHTML += aRow[2];
	strHTML += "<input type=\"hidden\" name=\"" + objTable.aVarNamePrefixes[2] + row + "\" value=\"" + aRow[2] + "\">";
	strHTML += "<\/td>";
	strHTML += "<td class=\"clsEntry\">";
	strHTML += aRow[3];
	strHTML += "<input type=\"hidden\" name=\"" + objTable.aVarNamePrefixes[3] + row + "\" value=\"" + aRow[3] + "\">";
	strHTML += "<\/td>";
	strHTML += "<td class=\"clsEntry\">";
	strHTML += aRow[4];
	strHTML += "<input type=\"hidden\" name=\"" + objTable.aVarNamePrefixes[4] + row + "\" value=\"" + aRow[4] + "\">";
	strHTML += "<\/td>";
	strHTML += "<td class=\"clsEntry\">";
	strHTML += aRow[5];
	strHTML += "<input type=\"hidden\" name=\"" + objTable.aVarNamePrefixes[5] + row + "\" value=\"" + aRow[5] + "\">";
	strHTML += "<\/td>";
	strHTML += "<td>";
	strHTML += "<input type=\"button\" value=\"Delete\" class=\"clsSmall\" onclick=\"tableDeleteRowDDNS(" + objTable.strThis + ", " + row + ", 'idChangesDDNS');\">";
	strHTML += "<\/td>";
	strHTML += "<td class=\"clsEntry\">";
	strHTML += "<a href=\"http:\/\/" + aRow[6] + "\" target=\"_new\">Manage<\/a>";
	strHTML += "<\/td>"
	strHTML += "<\/tr>";
	return strHTML;
}

function tableAddRowDDNS()
{	
	var link = "";
	var service = document.idForm.ddnsService.value;
	
	if (service == "dyndns")
		link = "www.dyndns.org";
	else if (service == "dtdns")
		link = "www.dtdns.net";
	else if (service == "noip")
		link = "www.no-ip.com";
	else if (service == "tzo")
		link = "www.tzo.com";
		
	var aRowNew = new Array(	"on",
				document.idForm.ddnsService.value,
				document.idForm.ddnsHostname.value,
				document.idForm.ddnsUsername.value,
				document.idForm.ddnsPasswd.value,
					"inactive",
				link
			);
	
	if (validateDataDDNS(aRowNew) && !tableIsDuplicateRow(objTableDDNS, aRowNew))
	{	tableAddRow(objTableDDNS, aRowNew);
		setVisibility("idChangesDDNS", true);
	}
}

/*
	Returns true if the passed string is :.
*/
function containsColon(str)
{
   return (str.indexOf(":") >= 0);
}
	
function validateDataDDNS(aRow)
{
	var strField = "";
	var strColon = "";
	
	if (aRow[1] == "")
		strField = "Provider";
	else if (aRow[2] == "")
		strField = "Host name";
	else if (aRow[3] == "")
		strField = "User name";
	else if (aRow[4] == "") 
		strField = "Password";
	
	if (containsColon(aRow[1]))
		strColon = ":";
	else if (containsColon(aRow[2]))
		strColon = ":";
	else if (containsColon(aRow[3]))
		strColon = ":";
	else if (containsColon(aRow[4]))
		strColon = ":";
		
	var strMsg1 = "";
	var strMsg2 = "";
	
	if (strField != "")
		strMsg1 = "Please enter a value for " + strField + ".";
	if (strColon != "")
		strMsg2 = "Please do not use : character.";
			
	if ((strMsg1 == "") && (strMsg2 == ""))
		return true;
	alert(strMsg1);
	alert(strMsg2);
	return false;
}


function tableDisplay(objTable)
{	var inside = "";
	inside += "<input type=\"hidden\" name=\"" + objTable.strVarNameNum + "\" value=\"" + objTable.aRows.length + "\">";
	if (objTable.aRows.length > 0)
	{	inside += "<table class=\"clsRuled\">";
		inside += "<thead><tr valign=\"bottom\">";
		for (var col in objTable.aHeadings)
		{	inside += "<th align=\"left\">";
			inside += objTable.aHeadings[col];
			inside += "<\/th>";
		}
		inside += "<th><\/th>";	
		inside += "<\/tr><\/thead>";
		inside += "<tbody>";
		for (var row in objTable.aRows)
			inside += objTable.fctFormatRow(objTable, row);
		inside += "<\/tbody><\/table>";
	}
	objTable.eltTable.innerHTML = inside;
	objTable.eltBtnAdd.disabled = (objTable.aRows.length == objTable.iMaxNumRows);
}

function fctFormatRowText(objTable, row)
{	var strHTML = "<tr>";
	var aRow = objTable.aRows[row];
	for (var col in aRow)
	{	strHTML += "<td class=\"clsEntry\">";
		strHTML += aRow[col];
		strHTML += "<input type=\"hidden\" name=\"" + objTable.aVarNamePrefixes[col] + row + "\" value=\"" + aRow[col] + "\">";
		strHTML += "<\/td>";
	}
	strHTML += "<td>";
	strHTML += "<input type=\"button\" value=\"Delete\" class=\"clsSmall\" onclick=\"tableDeleteRow(" + objTable.strThis + ", " + row + ");\">";
	strHTML += "<\/td>";
	strHTML += "<\/tr>";
	return strHTML;
}

function tableAddRow(objTable, aRowNew)
{	objTable.aRows.push(aRowNew);
	tableDisplay(objTable);
	bDirty = true;
}

function validateDataText(objTable, aRow)
{	for (var col in aRow)
	{	if (aRow[col] == "")
		{	alert("Please enter a value for " + objTable.aHeadings[col] + ".");
			return false;
		}
	}
	return true;
}

function tableIsDuplicateRow(objTable, aRow)
{	for (var i in objTable.aRows)
	{	var bSame = true;
		for (var e in aRow)
		{	if (aRow[e] != objTable.aRows[i][e])
			{	bSame = false;
				break;
			}
		}
		if (bSame)
			return true;
	}
	return false;
}

function tableDeleteRow(objTable, ixRow)
{	for (var i = ixRow; i < objTable.aRows.length; ++i)
		objTable.aRows[i] = objTable.aRows[i + 1];
	--objTable.aRows.length;
	tableDisplay(objTable);
	bDirty = true;
}

function tableModifyValue(objTable, row, col)
{	objTable.aRows[row][col] = (objTable.aRows[row][col] == "on") ? "off" : "on";
	tableDisplay(objTable);
	bDirty = true;
}

function changeAcceleration()
{	var ixAccel = document.idForm.cbAcceleration.selectedIndex;
	if (ixAccel == 2)
	{	setEnabled("lblFrag", false);
		setEnabled("wl_frag", false);
		document.idForm.wl_frag.value = "2346";
	}
	else
	{	setEnabled("lblFrag", true);
		setEnabled("wl_frag", true);
	}
}

function set_encryption()
{	var ix = document.idForm.cbAuthEncrypt.selectedIndex;
	if (ix == 0)
		document.idForm.cbEncryption.value="tkip+aes";
	else	
		document.idForm.cbEncryption.value="none";
}

function checklog()
{	if (!document.idForm.chkSystemLog.checked)
		document.idForm.log_ipaddr.value="";
}

function validateKey(elt)
{	var bOK = false;
	if (/^\d{1,5}$/.test(elt.value))
		bOK = true;
	if (!bOK){
		alert("Please enter a valid key rotation.\n\nThe key rotation value has to be a number between 0 and 99,999.");
		elt.focus();
	}return bOK;
}

